diff --exclude=CVS -Nru certi/libRTI/RTIambassador.cc certi.new/libRTI/RTIambassador.cc
--- certi/libRTI/RTIambassador.cc	2008-11-21 14:41:52.000000000 +0100
+++ certi.new/libRTI/RTIambassador.cc	2008-12-05 18:27:42.000000000 +0100
@@ -26,6 +26,7 @@
 #include "certi.hh"
 
 #include "RTIambPrivateRefs.hh"
+#include "HandleSets.hh"
 
 #include "FedRegion.hh"
 #include "Message.hh"
@@ -74,7 +75,7 @@
 
 RTI::Handle
 get_handle(const RTI::Region &region)
-    throw (RegionNotKnown, RTIinternalError)
+    throw (RTI::RegionNotKnown, RTI::RTIinternalError)
 {
     try {
 	return dynamic_cast<const FedRegion &>(region).getHandle();
@@ -87,7 +88,7 @@
 
 char *
 hla_strdup(const std::string &s)
-    throw (RTIinternalError)
+    throw (RTI::RTIinternalError)
 {
     try {
         size_t len = s.length();
@@ -114,7 +115,7 @@
 */
 
 RTI::RTIambassador::RTIambassador()
-    throw (MemoryExhausted, RTIinternalError)
+    throw (RTI::MemoryExhausted, RTI::RTIinternalError)
 {
     G.Out(pdGendoc,"enter RTIambassador::RTIambassador");
     PrettyDebug::setFederateName( "Federate" );
@@ -156,7 +157,7 @@
 	         << GetLastError() <<"> "
 	         << "Cannot connect to RTIA.exe";		
 		//perror("CreateProcess");
-		 throw RTIinternalError( msg.str().c_str());
+		 throw RTI::RTIinternalError( msg.str().c_str());
 		}
     
    privateRefs->handle_RTIA = pi.hProcess;
@@ -175,7 +176,7 @@
     switch((privateRefs->pid_RTIA = fork())) {
       case -1: // fork failed.
         perror("fork");
-        throw RTIinternalError("fork failed in RTIambassador constructor");
+        throw RTI::RTIinternalError("fork failed in RTIambassador constructor");
         break ;
 
       case 0: // child process (RTIA).
@@ -184,7 +185,7 @@
             << strerror(errno)
             << endl
             << "Maybe RTIA is not in search PATH environment.";        
-        throw RTIinternalError(msg.str().c_str());
+        throw RTI::RTIinternalError(msg.str().c_str());
         
       default: // father process (Federe).
     	// We sleep before trying to connect to the socket
@@ -198,7 +199,7 @@
         {
            D.Out( pdError, "Cannot connect to RTIA. Abort." ) ;
            kill( privateRefs->pid_RTIA, SIGINT ) ;
-           throw RTIinternalError( "Cannot connect to RTIA" ) ;
+           throw RTI::RTIinternalError( "Cannot connect to RTIA" );
         };
         break ;
     }
@@ -214,7 +215,7 @@
 /*! When destructor is called, kill rtia process.
  */
 RTI::RTIambassador::~RTIambassador()
-    throw (RTIinternalError)
+    throw (RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -235,7 +236,7 @@
 RTI::RTIambassador::tick()
     throw (SpecifiedSaveLabelDoesNotExist,
            ConcurrentAccessAttempted,
-           RTIinternalError)
+           RTI::RTIinternalError)
 {
    __tick_kernel(RTI_FALSE, 0.0, 0.0);
    return RTI_FALSE;
@@ -250,9 +251,9 @@
  */
 RTI::Boolean
 RTI::RTIambassador::tick2()
-    throw (SpecifiedSaveLabelDoesNotExist,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpecifiedSaveLabelDoesNotExist,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
    __tick_kernel(RTI_FALSE, std::numeric_limits<double>::infinity(), 0.0);
    return RTI_FALSE;
@@ -267,9 +268,9 @@
  */
 RTI::Boolean
 RTI::RTIambassador::__tick_kernel(RTI::Boolean multiple, TickTime minimum, TickTime maximum)
-    throw (SpecifiedSaveLabelDoesNotExist,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpecifiedSaveLabelDoesNotExist,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message vers_RTI, vers_Fed ;
 
@@ -286,7 +287,7 @@
         std::stringstream msg;
         msg << "NetworkError in tick() while sending TICK_REQUEST: " << e._reason;
 
-        throw RTIinternalError(msg.str().c_str());
+        throw RTI::RTIinternalError(msg.str().c_str());
     }
 
     // Read response(s) from the local RTIA until Message::TICK_REQUEST is received.
@@ -298,7 +299,7 @@
             std::stringstream msg;
             msg << "NetworkError in tick() while receiving response: " << e._reason;
 
-            throw RTIinternalError(msg.str().c_str());
+            throw RTI::RTIinternalError(msg.str().c_str());
         }
 
         //D.Mes( pdMessage, 'M', vers_Fed.type);
@@ -318,7 +319,7 @@
             // Otherwise, the RTI calls a FederateAmbassador service.
             privateRefs->callFederateAmbassador(&vers_Fed);
         }
-        catch (RTIinternalError) {
+        catch (RTI::RTIinternalError) {
             // RTIA awaits TICK_REQUEST_NEXT, terminate the tick() processing
             privateRefs->sendTickRequestStop();
             // ignore the response and re-throw the original exception
@@ -336,7 +337,7 @@
             std::stringstream msg;
             msg << "NetworkError in tick() while sending TICK_REQUEST_NEXT: " << e._reason;
 
-            throw RTIinternalError(msg.str().c_str());
+            throw RTI::RTIinternalError(msg.str().c_str());
         }
     } // while(1)
 }
@@ -350,8 +351,8 @@
  */
 RTI::Boolean
 RTI::RTIambassador::tick(TickTime minimum, TickTime maximum)
-    throw (SpecifiedSaveLabelDoesNotExist, ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpecifiedSaveLabelDoesNotExist, RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     return __tick_kernel(RTI_TRUE, minimum, maximum);
 }
@@ -373,7 +374,7 @@
     throw (RTI::FederateNotExecutionMember, RTI::ConcurrentAccessAttempted,
            RTI::RegionNotKnown, RTI::RTIinternalError)
 {
-    throw UnimplementedService("");
+    throw RTI::RTIinternalError("unimplemented service getRegion");
 }
 
 // ----------------------------------------------------------------------------
@@ -458,9 +459,9 @@
     G.Out(pdGendoc,"enter RTIambassador::joinFederationExecution");
 
     if ( yourName == NULL || strlen(yourName) == 0 )
-        throw RTIinternalError("Incorrect or empty federate name");
+        throw RTI::RTIinternalError("Incorrect or empty federate name");
     if ( executionName == NULL || strlen(executionName) == 0 )
-        throw RTIinternalError("Incorrect or empty federation name");
+        throw RTI::RTIinternalError("Incorrect or empty federation name");
 
     privateRefs->fed_amb = (FederateAmbassador *) fedamb ;
 
@@ -477,11 +478,11 @@
 //! Resign Federation Execution.
 void
 RTI::RTIambassador::resignFederationExecution(ResignAction theAction)
-    throw (FederateOwnsAttributes,
-           FederateNotExecutionMember,
-           InvalidResignAction,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::FederateOwnsAttributes,
+           RTI::FederateNotExecutionMember,
+           RTI::InvalidResignAction,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -507,11 +508,11 @@
 void
 RTI::RTIambassador::registerFederationSynchronizationPoint(const char *label,
                                                       const char *the_tag)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -521,7 +522,7 @@
     req.setLabel(label);
     if ( the_tag == NULL )
        {
-       throw RTIinternalError ("Calling registerFederationSynchronizationPoint with Tag NULL");
+       throw RTI::RTIinternalError ("Calling registerFederationSynchronizationPoint with Tag NULL");
        }
     req.setTag(the_tag);
     // boolean false because without set of federates
@@ -557,7 +558,7 @@
     req.setLabel(label);
     if ( theTag == NULL )
        {
-       throw RTIinternalError ("Calling registerFederationSynchronizationPoint with Tag NULL");
+       throw RTI::RTIinternalError ("Calling registerFederationSynchronizationPoint with Tag NULL");
        }
     req.setTag(theTag);
     // boolean must be true because federate set exists but if size=0 (set empty)
@@ -588,12 +589,12 @@
 //! Synchronization Point Achieved
 void
 RTI::RTIambassador::synchronizationPointAchieved(const char *label)
-    throw (SynchronizationPointLabelWasNotAnnounced,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::SynchronizationPointLabelWasNotAnnounced,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -612,13 +613,13 @@
 void
 RTI::RTIambassador::requestFederationSave(const char *label,
                                      const FedTime& theTime)
-    throw (FederationTimeAlreadyPassed,
-           InvalidFederationTime,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederationTimeAlreadyPassed,
+           RTI::InvalidFederationTime,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -640,11 +641,11 @@
 //! Request Federation Save without time.
 void
 RTI::RTIambassador::requestFederationSave(const char *label)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -666,11 +667,11 @@
 //! Federate Save Begun.
 void
 RTI::RTIambassador::federateSaveBegun()
-    throw (SaveNotInitiated,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::SaveNotInitiated,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -687,11 +688,11 @@
 //! Federate Save Complete.
 void
 RTI::RTIambassador::federateSaveComplete()
-    throw (SaveNotInitiated,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::SaveNotInitiated,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -707,11 +708,11 @@
 // Federate Save Not Complete.
 void
 RTI::RTIambassador::federateSaveNotComplete()
-    throw (SaveNotInitiated,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::SaveNotInitiated,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
 
     Message req, rep ;
@@ -795,7 +796,7 @@
 
     req.type = Message::PUBLISH_OBJECT_CLASS ;
     req.setObjectClass(theClass);
-    req.setAHS(attributeList);
+    req.setAHS(cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
     G.Out(pdGendoc,"      ====>executeService PUBLISH_OBJECT_CLASS");
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::publishObjectClass");
@@ -869,7 +870,7 @@
     G.Out(pdGendoc,"enter RTIambassador::subscribeObjectClassAttributes");
     req.type = Message::SUBSCRIBE_OBJECT_CLASS_ATTRIBUTES ;
     req.setObjectClass(theClass);
-    req.setAHS(attributeList);
+    req.setAHS(cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
     req.setBoolean(active);
 
     privateRefs->executeService(&req, &rep);
@@ -980,15 +981,15 @@
                       const AttributeHandleValuePairSet& theAttributes,
                       const FedTime& theTime,
                       const char *theTag)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeNotOwned,
-           InvalidFederationTime,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotOwned,
+           RTI::InvalidFederationTime,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     G.Out(pdGendoc,"enter RTIambassador::updateAttributeValues with time");
     Message req, rep ;
@@ -998,10 +999,10 @@
     req.setFedTime(theTime);
     if ( theTag == NULL)
        {
-       throw RTIinternalError ("Calling updateAttributeValues with Tag NULL");
+       throw RTI::RTIinternalError ("Calling updateAttributeValues with Tag NULL");
        }
     req.setTag(theTag);
-    req.setAHVPS(theAttributes);
+    req.setAHVPS(cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
     req.setBoolean(true);
 
     privateRefs->executeService(&req, &rep);
@@ -1034,10 +1035,10 @@
     req.setObject(the_object);
     if ( theTag == NULL)
        {
-       throw RTIinternalError ("Calling updateAttributeValues with Tag NULL");
+       throw RTI::RTIinternalError ("Calling updateAttributeValues with Tag NULL");
        }
     req.setTag(theTag);
-    req.setAHVPS(theAttributes);
+    req.setAHVPS(cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
     req.setBoolean(false);
 
     privateRefs->executeService(&req, &rep);
@@ -1058,15 +1059,15 @@
                                const ParameterHandleValuePairSet& theParameters,
                                const FedTime& theTime,
                                const char *theTag)
-    throw (InteractionClassNotDefined,
-           InteractionClassNotPublished,
-           InteractionParameterNotDefined,
-           InvalidFederationTime,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::InteractionClassNotPublished,
+           RTI::InteractionParameterNotDefined,
+           RTI::InvalidFederationTime,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1075,10 +1076,10 @@
     req.setFedTime(theTime);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling sendInteraction with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling sendInteraction with Tag NULL") ;
        }
     req.setTag((std::string)theTag);
-    req.setPHVPS(theParameters);
+    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
     req.setRegion(0);
     req.setBoolean(true);
 
@@ -1111,10 +1112,10 @@
     req.setInteractionClass(theInteraction);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling sendIntercation with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling sendIntercation with Tag NULL") ;
        }
     req.setTag((std::string)theTag);
-    req.setPHVPS(theParameters);
+    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
     req.setRegion(0);
     req.setBoolean(false);
   
@@ -1133,14 +1134,14 @@
 RTI::RTIambassador::deleteObjectInstance(ObjectHandle theObject,
                                     const FedTime& theTime,
                                     const char *theTag)
-    throw (ObjectNotKnown,
-           DeletePrivilegeNotHeld,
-           InvalidFederationTime,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::DeletePrivilegeNotHeld,
+           RTI::InvalidFederationTime,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1149,7 +1150,7 @@
     req.setFedTime(theTime);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
        }
     req.setTag(theTag);
     req.setBoolean(true);
@@ -1177,7 +1178,7 @@
     req.setObject(theObject);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
        }
     req.setTag(theTag);
    
@@ -1194,7 +1195,7 @@
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::FederateOwnsAttributes, RTI::ObjectNotKnown)
 {
-    throw UnimplementedService("");
+    throw RTI::RTIinternalError("unimplemented service localDeleteObjectInstance");
     Message req, rep ;
 
     req.type = Message::LOCAL_DELETE_OBJECT_INSTANCE ;
@@ -1221,7 +1222,7 @@
     req.type = Message::CHANGE_ATTRIBUTE_TRANSPORTATION_TYPE ;
     req.setObject(theObject);
     req.setTransportation(theType);
-    req.setAHS(theAttributes);
+    req.setAHS(cast<AttributeHandleSetImp>()(theAttributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1261,7 +1262,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestObjectAttributeValueUpdate");
     req.type = Message::REQUEST_OBJECT_ATTRIBUTE_VALUE_UPDATE ;
     req.setObject(theObject);
-    req.setAHS(ahs);
+    req.setAHS(cast<AttributeHandleSetImp>()(ahs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::requestObjectAttributeValueUpdate");
@@ -1282,7 +1283,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestClassAttributeValueUpdate");
     req.type = Message::REQUEST_CLASS_ATTRIBUTE_VALUE_UPDATE ;
     req.setObjectClass(theClass);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::requestClassAttributeValueUpdate");
@@ -1294,20 +1295,20 @@
 RTI::RTIambassador::
 unconditionalAttributeOwnershipDivestiture(ObjectHandle theObject,
                                            const AttributeHandleSet &attrs)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeNotOwned,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotOwned,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.type = Message::UNCONDITIONAL_ATTRIBUTE_OWNERSHIP_DIVESTITURE ;
     req.setObject(theObject);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1319,15 +1320,15 @@
 negotiatedAttributeOwnershipDivestiture(ObjectHandle theObject,
                                         const AttributeHandleSet& attrs,
                                         const char *theTag)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeNotOwned,
-           AttributeAlreadyBeingDivested,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotOwned,
+           RTI::AttributeAlreadyBeingDivested,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1335,10 +1336,10 @@
     req.setObject(theObject);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling negotiatedAttributeOwnershipDivestiture with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling negotiatedAttributeOwnershipDivestiture with Tag NULL") ;
        }
     req.setTag(theTag);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1350,16 +1351,16 @@
 attributeOwnershipAcquisition(ObjectHandle theObject,
                               const AttributeHandleSet& desiredAttributes,
                               const char *theTag)
-    throw (ObjectNotKnown,
-           ObjectClassNotPublished,
-           AttributeNotDefined,
-           AttributeNotPublished,
-           FederateOwnsAttributes,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::ObjectClassNotPublished,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotPublished,
+           RTI::FederateOwnsAttributes,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1367,40 +1368,40 @@
     req.setObject(theObject);
     if (theTag == NULL)
        {
-       throw RTIinternalError ("Calling attributeOwnershipAcquisition with Tag NULL") ;
+       throw RTI::RTIinternalError ("Calling attributeOwnershipAcquisition with Tag NULL") ;
        }
     req.setTag(theTag);
-    req.setAHS(desiredAttributes);
+    req.setAHS(cast<AttributeHandleSetImp>()(desiredAttributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Attribute Ownership Release Response
-AttributeHandleSet*
+RTI::AttributeHandleSet*
 RTI::RTIambassador::
 attributeOwnershipReleaseResponse(ObjectHandle theObject,
                                   const AttributeHandleSet& attrs)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeNotOwned,
-           FederateWasNotAskedToReleaseAttribute,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotOwned,
+           RTI::FederateWasNotAskedToReleaseAttribute,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.type = Message::ATTRIBUTE_OWNERSHIP_RELEASE_RESPONSE ;
     req.setObject(theObject);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 
     if (rep.getExceptionType() == e_NO_EXCEPTION) {
-        return rep.getAHS();
+        return new AttributeHandleSetImp(rep.getAHS());
     }
 
     return NULL ;
@@ -1412,21 +1413,21 @@
 RTI::RTIambassador::
 cancelNegotiatedAttributeOwnershipDivestiture(ObjectHandle theObject,
                                               const AttributeHandleSet& attrs)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeNotOwned,
-           AttributeDivestitureWasNotRequested,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotOwned,
+           RTI::AttributeDivestitureWasNotRequested,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.type = Message::CANCEL_NEGOTIATED_ATTRIBUTE_OWNERSHIP_DIVESTITURE ;
     req.setObject(theObject);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1437,21 +1438,21 @@
 RTI::RTIambassador::
 cancelAttributeOwnershipAcquisition(ObjectHandle theObject,
                                     const AttributeHandleSet& attrs)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           AttributeAlreadyOwned,
-           AttributeAcquisitionWasNotRequested,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::AttributeAlreadyOwned,
+           RTI::AttributeAcquisitionWasNotRequested,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.type = Message::CANCEL_ATTRIBUTE_OWNERSHIP_ACQUISITION ;
     req.setObject(theObject);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1462,23 +1463,23 @@
 RTI::RTIambassador::
 attributeOwnershipAcquisitionIfAvailable(ObjectHandle theObject,
                                          const AttributeHandleSet& desired)
-    throw (ObjectNotKnown,
-           ObjectClassNotPublished,
-           AttributeNotDefined,
-           AttributeNotPublished,
-           FederateOwnsAttributes,
-           AttributeAlreadyBeingAcquired,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::ObjectClassNotPublished,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotPublished,
+           RTI::FederateOwnsAttributes,
+           RTI::AttributeAlreadyBeingAcquired,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.type = Message::ATTRIBUTE_OWNERSHIP_ACQUISITION_IF_AVAILABLE ;
     req.setObject(theObject);
-    req.setAHS(desired);
+    req.setAHS(cast<AttributeHandleSetImp>()(desired).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1508,13 +1509,13 @@
 RTI::Boolean
 RTI::RTIambassador::isAttributeOwnedByFederate(ObjectHandle theObject,
                                           AttributeHandle theAttribute)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1565,14 +1566,14 @@
 // Enable Time Constrained
 void
 RTI::RTIambassador::enableTimeConstrained()
-    throw (TimeConstrainedAlreadyEnabled, //not implemented
-           EnableTimeConstrainedPending, //not implemented
-           TimeAdvanceAlreadyInProgress, //not implemented
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::TimeConstrainedAlreadyEnabled, //not implemented
+           RTI::EnableTimeConstrainedPending, //not implemented
+           RTI::TimeAdvanceAlreadyInProgress, //not implemented
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1585,12 +1586,12 @@
 // Disable Time Constrained
 void
 RTI::RTIambassador::disableTimeConstrained()
-    throw (TimeConstrainedWasNotEnabled, //not implemented
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::TimeConstrainedWasNotEnabled, //not implemented
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1603,16 +1604,16 @@
 // Time Advance Request
 void
 RTI::RTIambassador::timeAdvanceRequest(const FedTime& theTime)
-    throw (TimeAdvanceAlreadyInProgress,
-           FederationTimeAlreadyPassed,
-           InvalidFederationTime,
-           EnableTimeRegulationPending, //not implemented
-           EnableTimeConstrainedPending, //not implemented
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::TimeAdvanceAlreadyInProgress,
+           RTI::FederationTimeAlreadyPassed,
+           RTI::InvalidFederationTime,
+           RTI::EnableTimeRegulationPending, //not implemented
+           RTI::EnableTimeConstrainedPending, //not implemented
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
